#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2000five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 2000"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
6#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five20004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five20004xi = {
                1: '-1007x217y1713z',
                2: '-1017x1129y1299z',
                3: '-1029x1004y1389z',
                4: '-1034x167y1703z',
                5: '-104x11y1997z',
                6: '-1058x114y1692z',
                7: '-1065x1593y570z',
                8: '-1080x60y1682z',
                9: '-1084x1084y1284z',
                10: '-1091x958y1375z',
                11: '-1098x3y1671z',
                12: '-1148x1034y1268z',
                13: '-1150x1539y551z',
                14: '-1150x908y1360z',
                15: '-1207x854y1346z',
                16: '-1211x980y1253z',
                17: '-1233x1481y532z',
                18: '-124x7y1996z',
                19: '-1261x797y1331z',
                20: '-1271x923y1237z',
                21: '-129x618y1897z',
                22: '-1312x1418y512z',
                23: '-1313x736y1316z',
                24: '-1327x862y1221z',
                25: '-1361x672y1301z',
                26: '-1381x797y1205z',
                27: '-1388x1351y493z',
                28: '-1407x605y1285z',
                29: '-141x1346y1472z',
                30: '-1432x729y1189z',
                31: '-1448x535y1270z',
                32: '-144x0y1994z',
                33: '-1461x1280y474z',
                34: '-1479x658y1173z',
                35: '-1486x462y1254z',
                36: '-1521x387y1239z',
                37: '-1522x584y1157z',
                38: '-1530x1205y454z',
                39: '-1551x309y1223z',
                40: '-1562x507y1141z',
                41: '-1577x229y1207z',
                42: '-1594x1125y435z',
                43: '-1597x428y1124z',
                44: '-1599x148y1191z',
                45: '-1628x346y1108z',
                46: '-1655x1043y415z',
                47: '-1655x262y1091z',
                48: '-166x629y1891z',
                49: '-1677x176y1074z',
                50: '-1695x88y1057z',
                51: '-1697x67y1234z',
                52: '-1707x0y1040z',
                53: '-1710x957y395z',
                54: '-1762x867y376z',
                55: '-1808x776y356z',
                56: '-1849x681y337z',
                57: '-1886x584y317z',
                58: '-1917x485y297z',
                59: '-1942x385y277z',
                60: '-1962x283y257z',
                61: '-1977x180y238z',
                62: '-1986x77y218z',
                63: '-204x637y1884z',
                64: '-212x1243y1551z',
                65: '-214x1351y1458z',
                66: '-219x1844y740z',
                67: '-23x7y1999z',
                68: '-244x643y1877z',
                69: '-280x1245y1539z',
                70: '-285x647y1870z',
                71: '-287x1352y1444z',
                72: '-316x1838y721z',
                73: '-327x647y1863z',
                74: '-349x1244y1526z',
                75: '-361x1349y1430z',
                76: '-370x646y1856z',
                77: '-413x641y1848z',
                78: '-414x1825y703z',
                79: '-419x1238y1513z',
                80: '-436x1342y1416z',
                81: '-43x11y1999z',
                82: '-457x633y1840z',
                83: '-489x1228y1500z',
                84: '-4x1y1999z',
                85: '-501x623y1833z',
                86: '-510x1331y1402z',
                87: '-510x1808y684z',
                88: '-545x609y1824z',
                89: '-559x1215y1486z',
                90: '-585x1315y1388z',
                91: '-589x593y1816z',
                92: '-607x1785y665z',
                93: '-60x590y1909z',
                94: '-628x1197y1473z',
                95: '-633x573y1808z',
                96: '-63x13y1998z',
                97: '-659x1295y1373z',
                98: '-676x551y1799z',
                99: '-698x1175y1459z',
                100: '-702x1757y646z',
                101: '-718x525y1790z',
                102: '-733x1270y1359z',
                103: '-760x497y1781z',
                104: '-766x1149y1446z',
                105: '-795x1724y627z',
                106: '-800x465y1772z',
                107: '-806x1241y1344z',
                108: '-834x1119y1432z',
                109: '-839x431y1763z',
                110: '-83x13y1998z',
                111: '-877x393y1753z',
                112: '-878x1208y1329z',
                113: '-887x1685y608z',
                114: '-900x1084y1418z',
                115: '-912x353y1744z',
                116: '-93x605y1903z',
                117: '-946x310y1734z',
                118: '-948x1171y1314z',
                119: '-966x1046y1404z',
                120: '-977x1641y589z',
                121: '-978x265y1724z'}         

#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2000five4xi" usage = "target function for charge20004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire2000five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2000FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2000FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2000FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2000FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2000FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five20004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2000FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2000FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2000FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five20004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five20004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2000FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2000FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2000FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2000five4xi.py                             
# -------------------------------------------------------------------------------------------------                